# borg prune

    borg [common options] prune [options] [REPOSITORY]

positional arguments
| `REPOSITORY` | repository to prune
optional arguments
| `-n`, `--dry-run` | do not change repository
| `--force` | force pruning of corrupted archives
| `-s`, `--stats` | print statistics for the deleted archive
| `--list` | output verbose list of archives it keeps/prunes
| `--keep-within INTERVAL` | keep all archives within this time interval
| `--keep-last`, `--keep-secondly` | number of secondly archives to keep
| `--keep-minutely` | number of minutely archives to keep
| `-H`, `--keep-hourly` | number of hourly archives to keep
| `-d`, `--keep-daily` | number of daily archives to keep
| `-w`, `--keep-weekly` | number of weekly archives to keep
| `-m`, `--keep-monthly` | number of monthly archives to keep
| `-y`, `--keep-yearly` | number of yearly archives to keep
| `--save-space` | work slower, but using less space
Common options
Archive filters — Archive filters can be applied to repository targets.
| `-P PREFIX`, `--prefix PREFIX` | only consider archive names starting with this prefix.
| `-a GLOB`, `--glob-archives GLOB` | only consider archive names matching the glob. sh: rules apply, see “borg help patterns”. `--prefix` and `--glob-archives` are mutually exclusive.

## Description

The prune command prunes a repository by deleting all archives not matching any of the specified retention options. This command is normally used by automated backup scripts wanting to keep a certain number of historic backups.

Also, prune automatically removes checkpoint archives (incomplete archives left behind by interrupted backup runs) except if the checkpoint is the latest archive (and thus still needed). Checkpoint archives are not considered when comparing archive counts against the retention limits (`--keep-X`).

If a prefix is set with -P, then only archives that start with the prefix are considered for deletion and only those archives count towards the totals specified by the rules. Otherwise, all archives in the repository are candidates for deletion! There is no automatic distinction between archives representing different contents. These need to be distinguished by specifying matching prefixes.

If you have multiple sequences of archives with different data sets (e.g. from different machines) in one shared repository, use one prune call per data set that matches only the respective archives using the -P option.

The `--keep-within` option takes an argument of the form “<int><char>”, where char is “H”, “d”, “w”, “m”, “y”. For example, `--keep-within 2d` means to keep all archives that were created within the past 48 hours. “1m” is taken to mean “31d”. The archives kept with this option do not count towards the totals specified by any other options.

A good procedure is to thin out more and more the older your backups get. As an example, `--keep-daily 7` means to keep the latest backup on each day, up to 7 most recent days with backups (days without backups do not count). The rules are applied from secondly to yearly, and backups selected by previous rules do not count towards those of later rules. The time that each backup starts is used for pruning purposes. Dates and times are interpreted in the local timezone, and weeks go from Monday to Sunday. Specifying a negative number of archives to keep means that there is no limit.

The `--keep-last N` option is doing the same as `--keep-secondly N` (and it will keep the last N archives under the assumption that you do not create more than one backup archive in the same second).

## Examples

Be careful, prune is a potentially dangerous command, it will remove backup archives.

The default of prune is to apply to all archives in the repository unless you restrict its operation to a subset of the archives using `--prefix`. When using `--prefix`, be careful to choose a good prefix - e.g. do not use a prefix “foo” if you do not also want to match “foobar”.

It is strongly recommended to always run `prune -v --list --dry-run ...` first so you will see what it would do without it actually doing anything.

    # Keep 7 end of day and 4 additional end of week archives.
    # Do a dry-run without actually deleting anything.
    $ borg prune -v --list --dry-run --keep-daily=7 --keep-weekly=4 /path/to/repo

    # Same as above but only apply to archive names starting with the hostname
    # of the machine followed by a "-" character:
    $ borg prune -v --list --keep-daily=7 --keep-weekly=4 --prefix='{hostname}-' /path/to/repo

    # Keep 7 end of day, 4 additional end of week archives,
    # and an end of month archive for every month:
    $ borg prune -v --list --keep-daily=7 --keep-weekly=4 --keep-monthly=-1 /path/to/repo

    # Keep all backups in the last 10 days, 4 additional end of week archives,
    # and an end of month archive for every month:
    $ borg prune -v --list --keep-within=10d --keep-weekly=4 --keep-monthly=-1 /path/to/repo

There is also a visualized prune example in `docs/misc/prune-example.txt`:

    borg prune visualized
    =====================

    Assume it is 2016-01-01, today's backup has not yet been made and you have
    created at least one backup on each day in 2015 except on 2015-12-19 (no
    backup made on that day).

    This is what borg prune --keep-daily 14 --keep-monthly 6 would keep.

    Backups kept by the --keep-daily rule are marked by a "d" to the right,
    backups kept by the --keep-monthly rule are marked by a "m" to the right.

    Calendar view
    -------------

                                2015
          January               February               March
    Mo Tu We Th Fr Sa Su  Mo Tu We Th Fr Sa Su  Mo Tu We Th Fr Sa Su
              1  2  3  4                     1                     1
     5  6  7  8  9 10 11   2  3  4  5  6  7  8   2  3  4  5  6  7  8
    12 13 14 15 16 17 18   9 10 11 12 13 14 15   9 10 11 12 13 14 15
    19 20 21 22 23 24 25  16 17 18 19 20 21 22  16 17 18 19 20 21 22
    26 27 28 29 30 31     23 24 25 26 27 28     23 24 25 26 27 28 29
                                                30 31

           April                  May                   June
    Mo Tu We Th Fr Sa Su  Mo Tu We Th Fr Sa Su  Mo Tu We Th Fr Sa Su
           1  2  3  4  5               1  2  3   1  2  3  4  5  6  7
     6  7  8  9 10 11 12   4  5  6  7  8  9 10   8  9 10 11 12 13 14
    13 14 15 16 17 18 19  11 12 13 14 15 16 17  15 16 17 18 19 20 21
    20 21 22 23 24 25 26  18 19 20 21 22 23 24  22 23 24 25 26 27 28
    27 28 29 30           25 26 27 28 29 30 31  29 30m

            July                 August              September
    Mo Tu We Th Fr Sa Su  Mo Tu We Th Fr Sa Su  Mo Tu We Th Fr Sa Su
           1  2  3  4  5                  1  2      1  2  3  4  5  6
     6  7  8  9 10 11 12   3  4  5  6  7  8  9   7  8  9 10 11 12 13
    13 14 15 16 17 18 19  10 11 12 13 14 15 16  14 15 16 17 18 19 20
    20 21 22 23 24 25 26  17 18 19 20 21 22 23  21 22 23 24 25 26 27
    27 28 29 30 31m       24 25 26 27 28 29 30  28 29 30m
                          31m

          October               November              December
    Mo Tu We Th Fr Sa Su  Mo Tu We Th Fr Sa Su  Mo Tu We Th Fr Sa Su
              1  2  3  4                     1      1  2  3  4  5  6
     5  6  7  8  9 10 11   2  3  4  5  6  7  8   7  8  9 10 11 12 13
    12 13 14 15 16 17 18   9 10 11 12 13 14 15  14 15 16 17d18d19 20d
    19 20 21 22 23 24 25  16 17 18 19 20 21 22  21d22d23d24d25d26d27d
    26 27 28 29 30 31m    23 24 25 26 27 28 29  28d29d30d31d
                          30m

    List view
    ---------

    --keep-daily 14     --keep-monthly 6
    -------------------------------------------------
     1. 2015-12-31          (2015-12-31 kept by daily rule)
     2. 2015-12-30       1. 2015-11-30
     3. 2015-12-29       2. 2015-10-31
     4. 2015-12-28       3. 2015-09-30
     5. 2015-12-27       4. 2015-08-31
     6. 2015-12-26       5. 2015-07-31
     7. 2015-12-25       6. 2015-06-30
     8. 2015-12-24
     9. 2015-12-23
    10. 2015-12-22
    11. 2015-12-21
    12. 2015-12-20
        (no backup made on 2015-12-19)
    13. 2015-12-18
    14. 2015-12-17

    Notes
    -----

    2015-12-31 is kept due to the --keep-daily 14 rule (because it is applied
    first), not due to the --keep-monthly rule.

    Because of that, the --keep-monthly 6 rule keeps Nov, Oct, Sep, Aug, Jul and
    Jun. December is not considered for this rule, because that backup was already
    kept because of the daily rule.

    2015-12-17 is kept to satisfy the --keep-daily 14 rule - because no backup was
    made on 2015-12-19. If a backup had been made on that day, it would not keep
    the one from 2015-12-17.

    We did not include yearly, weekly, hourly, minutely or secondly rules to keep
    this example simple. They all work in basically the same way.

    The weekly rule is easy to understand roughly, but hard to understand in all
    details. If interested, read "ISO 8601:2000 standard week-based year".